try {
importScripts("../pjcl.js");
} catch(e) {throw new Error("could not import ../pjcl.js");}
try {
importScripts("../browserEntropy.js");
} catch(e) {throw new Error("could not import ../browserEntropy.js");}
try {
importScripts("AddStackToError.js");
} catch(e) {throw new Error("could not import AddStackToError.js");}

onmessage = function(e) { try {
	var entropy = e.data[0];
	var rbgStateStorage = new Object();
	pjclRBG128Instantiate(rbgStateStorage,entropy);
	var p = pjclHex2BigInt(e.data[1]);
	var q = pjclHex2BigInt(e.data[2]);
	var g = pjclHex2BigInt(e.data[3]);
	var x = pjclHex2BigInt(e.data[4]);
	var msg = pjclHex2BitArray(e.data[5]);
	var count = e.data[6];
	var repetitions = e.data[7];
	var minTotalTime = Number.POSITIVE_INFINITY;
	for (var j = 1; j <= repetitions; j++) {
		var t1 = performance.now();
		for (var i = 0; i < count; i++) {
			var o = pjclDSASignMsg(rbgStateStorage,p,q,g,x,msg);
		}
		var t2 = performance.now();		
		var totalTime = t2 - t1;
		if (totalTime < minTotalTime) {
			minTotalTime = totalTime;
		}
		if (j < repetitions) {
			postMessage([totalTime,j]);
		}
		else {
			var r_hex = pjclBigInt2Hex(o.r);
			var s_hex = pjclBigInt2Hex(o.s);
			postMessage([totalTime,j,r_hex,s_hex,minTotalTime]);
		}
	}
	close();
} catch(e) {
	throw new Error(pjclAddStackToError(e));
}}
